﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DSProdutosTableAdapters;

/// <summary>
/// Summary description for CategoriasBLL
/// </summary>

[System.ComponentModel.DataObject] 
public class CategoriasBLL
{
    private TbCategoriaTableAdapter _adapter;
    // Propriedade que contém o TableAdapter
    protected TbCategoriaTableAdapter Adapter
    {
        get
        {
            if (_adapter == null)
            {
                _adapter = new TbCategoriaTableAdapter();
            }
            return _adapter;
        }
    }

    // Método responsável pela listagem
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Select, true)]
    public DSProdutos.TbCategoriaDataTable GetCategorias()
    {
        return Adapter.GetData();
    }

    // Método responsável pela inserção
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Insert, true)]
    public bool NovaCategoria(string nome, string descricao, bool destaque)
    {
        // Se inserir apenas 1 categoria
        return (Adapter.NovaCategoria(nome, descricao, destaque) == 1);
        
    }

    // Método responsável pela exclusão
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Delete, true)]
    public bool EliminarCategoria(int id)
    {
        // Se eliminar apenas uma categoria
        return (Adapter.EliminarCategoria(id) == 1);
    }

    // Método responsável pela alteração
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Update, true)]
    public bool AlterarCategoria(string nome, string descricao, bool destaque, int id)
    {
        // Se alterar apenas 1 categoria
        return (Adapter.AlterarCategoria(nome, descricao, destaque, id)==1);
    }

	
}
