﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using DSProdutosTableAdapters;

/// <summary>
/// Summary description for ProdutosBLL
/// </summary>
[System.ComponentModel.DataObject] 
public class ProdutosBLL
{
    private TbProdutoTableAdapter _adapter;
    // Propriedade que contém o TableAdapter
    protected TbProdutoTableAdapter Adapter
    {
        get
        {
            if (_adapter == null)
            {
                _adapter = new TbProdutoTableAdapter();
            }
            return _adapter;
        }
    }

    // Método responsável pela listagem
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Select, true)]
    public DSProdutos.TbProdutoDataTable GetProdutos()
    {
        return Adapter.GetProdutos();
    }

    // Método responsável pela inserção
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Insert, true)]
    public bool NovoProduto(string nome, decimal precounitario, int quantidadeestoque, short porcentagemdesconto, int idcategoria, bool descontinuado)
    {
        // Se inserir apenas 1 categoria
        if(quantidadeestoque >= 0)
            return (Adapter.NovoProduto(nome, precounitario, quantidadeestoque, porcentagemdesconto, idcategoria, descontinuado) == 1);
        else
            throw new ApplicationException("Você não pode criar produtos com quantidade negativa!"); 
    }

    // Método responsável pela exclusão
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Delete, true)]
    public bool EliminarProduto(int id)
    {
        // Se eliminar apenas uma categoria
        return (Adapter.EliminarProduto(id) == 1);
    }

    // Método responsável pela alteração
    [System.ComponentModel.DataObjectMethodAttribute(
        System.ComponentModel.DataObjectMethodType.Update, true)]
    public bool AlterarProduto(string nome, decimal precounitario, int quantidadeestoque, short porcentagemdesconto, int idcategoria, bool descontinuado, int id)
    {
        // Se alterar apenas 1 categoria
        DSProdutos.TbProdutoDataTable produtos = Adapter.GetProdutoById(id);
        // Verifica se o if existe
        if (produtos.Count == 0)
            return false;
        // Se o produto estiver descontinuado, verifica se o preço unitário foi mudado
        if (descontinuado)
        {
            if(produtos[0].precounitario!=precounitario)
                throw new ApplicationException("Você não pode alterar o preço unitário de um produto descontinuado!"); 
        }
        return (Adapter.AlterarProduto( nome,  precounitario,  quantidadeestoque,  porcentagemdesconto,  idcategoria,  descontinuado,  id) == 1);
    }
}
